MANDATORY-compose = DEPLOY_HOSTS DEPLOY_TYPE TAG

pull-compose:
	@- echo "\n### pulling image(s)"
	@- $(foreach host,$(DEPLOY_HOSTS), \
		echo "$(host)"; \
		if test $(DOCKER_LOGIN) -eq 1 ; \
		then \
			ssh $(SSH_USER)@$(host) "docker login -u $(DOCKER_USER) -p $(DOCKER_PASS) $(DOCKER_REGISTRY)"; \
		fi; \
		ssh $(SSH_USER)@$(host) "docker pull $(DOCKER_IMAGE)"; \
	)

start-compose:
	@- echo "\n### starting service(s)"
	@- $(foreach host,$(DEPLOY_HOSTS), \
		echo "$(host)"; \
		ssh $(SSH_USER)@$(host) "cd $(DEPLOY_PATH)/$(DEPLOY_NAME); docker-compose up -d"; \
	)

stop-compose:
	@- echo "\n### stopping service(s)"
	@- $(foreach host,$(DEPLOY_HOSTS), \
		echo "$(host)"; \
		ssh $(SSH_USER)@$(host) "cd $(DEPLOY_PATH)/$(DEPLOY_NAME); docker-compose down"; \
	)
		
logs-compose:
	@- echo "\n### logs"
	@- ssh $(SSH_USER)@$(host) "cd $(DEPLOY_PATH)/$(DEPLOY_NAME); docker-compose logs -f $(service)"
	
restart-compose:
	@- $(foreach host,$(DEPLOY_HOSTS), \
		echo "$(host)"; \
		ssh $(SSH_USER)@$(host) "cd $(DEPLOY_PATH)/$(DEPLOY_NAME); docker-compose restart"; \
	)
