MANDATORY-kustomize = K8S_CONTEXT KUSTOMIZE_FOLDER NAMESPACE
# kustomize
#
# this uses kustomize to install stuff on k8s

start-kustomize:
	@- echo "\n### starting deployment with kustomize"
	@- echo "\n### setting kubernetes context to $(K8S_CONTEXT)"
	@ kubectl config use-context $(K8S_CONTEXT)

	@- echo "\n### editing kustomizations"

ifdef KUSTOMIZE_EDIT_NAMESPACE
	@- echo "\n### setting namespace to $(K8S_NAMESPACE)"
	@ cd $(KUSTOMIZE_FOLDER) && kustomize edit set namespace $(K8S_NAMESPACE)
endif

# actual deployment is happening here
	@- echo "\n### applying kustomizations"
	@ cd $(KUSTOMIZE_FOLDER) && kustomize build . | envsubst | kubectl apply -n $(NAMESPACE) -f -

pull-kustomize:
# nop

#TODO: implement annotation
#	ifeq ($KUSTOMIZE_EDIT),annotation)
#	@- $(kustomize edit set annotation .....)
#	endif

#TODO: implement buildmetadata
#	ifeq ($KUSTOMIZE_EDIT),buildmetadata)
#	@- $(kustomize edit set buildmetadata .....)
#	endif

#TODO: implement image
#	ifeq ($KUSTOMIZE_EDIT),image)
#	@- $(kustomize edit set image .....)
#	endif

#TODO: implement label
#	ifeq ($KUSTOMIZE_EDIT),label)
#	@- $(kustomize edit set label .....)
#	endif

#TODO: implement nameprefix
#	ifeq ($KUSTOMIZE_EDIT),nameprefix)
#	@- $(kustomize edit set nameprefix .....)
#	endif

#TODO: implement namesuffix
#	ifeq ($KUSTOMIZE_EDIT),namesuffix)
#	@- $(kustomize edit set namesuffix .....)
#	endif

#TODO: implement replicas
#	ifeq ($KUSTOMIZE_EDIT),replicas)
#	@- $(kustomize edit set replicas .....)
#	endif
